/*
 * Copyright (C) 2010 Yury P. Fedorchenko
 * yuryfdr@users.sf.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
package chgame;

class ECheckers extends GameInternal {

    boolean go1(int from, int field) {
        from = internal(from);
        field = internal(field);

        to = field;
        if (checkCapture1()) {
            BoolGrave capture = new BoolGrave(false);

            switch (board[from]) {
                case MAN1:
                    if (manCapture1(from, UL, capture)) {
                        return true;
                    }
                    if (manCapture1(from, UR, capture)) {
                        return true;
                    }
                    return false;
                case KING1:
                    if (kingCapture1(from, UL, capture)) {
                        return true;
                    }
                    if (kingCapture1(from, UR, capture)) {
                        return true;
                    }
                    if (kingCapture1(from, DL, capture)) {
                        return true;
                    }
                    if (kingCapture1(from, DR, capture)) {
                        return true;
                    }
                    return false;
            }

        } else {
            switch (board[from]) {
                case MAN1:
                    if ((to == (from - 6)) || (to == (from - 5))) {
                        board[from] = FREE;
                        if (to < 10) {
                            board[to] = KING1;
                        } else {
                            board[to] = MAN1;
                        }
                        return true;
                    }
                    return false;
                case KING1:
                    if ((to == (from - 6)) || (to == (from - 5))
                            || (to == (from + 5)) || (to == (from + 6))) {
                        board[from] = FREE;
                        board[to] = KING1;
                        return true;
                    }
                    return false;
            }
        }

        return false;
    }

    boolean go2_human(int from, int field) {
        from = internal(from);
        field = internal(field);

        to = field;

        if (checkCapture2()) {
            BoolGrave capture = new BoolGrave(false);

            switch (board[from]) {
                case MAN2:
                    if (manCapture2(from, DL, capture)) {
                        return true;
                    }
                    if (manCapture2(from, DR, capture)) {
                        return true;
                    }
                    return false;
                case KING2:
                    if (kingCapture2(from, UL, capture)) {
                        return true;
                    }
                    if (kingCapture2(from, UR, capture)) {
                        return true;
                    }
                    if (kingCapture2(from, DL, capture)) {
                        return true;
                    }
                    if (kingCapture2(from, DR, capture)) {
                        return true;
                    }
                    return false;
            }

        } else {
            switch (board[from]) {
                case MAN2:
                    if ((to == (from + 6)) || (to == (from + 5))) {
                        board[from] = FREE;
                        if (to > 42)//check this
                        {
                            board[to] = KING2;
                        } else {
                            board[to] = MAN2;
                        }
                        return true;
                    }
                    return false;
                case KING2:
                    if ((to == (from - 6)) || (to == (from - 5))
                            || (to == (from + 5)) || (to == (from + 6))) {
                        board[from] = FREE;
                        board[to] = KING2;
                        return true;
                    }
                    return false;
            }
        }

        return false;
    }

    boolean checkCapture2() {
        for (int i = 6; i < 48; i++) {
            switch (board[i]) {
                case MAN2:
                    if (board[i + 5] == MAN1 || board[i + 5] == KING1) {
                        if (board[i + 10] == FREE) {
                            return true;
                        }
                    }
                    if (board[i + 6] == MAN1 || board[i + 6] == KING1) {
                        if (board[i + 12] == FREE) {
                            return true;
                        }
                    }
                    break;
                case KING2:
                    if (board[i - 6] == MAN1 || board[i - 6] == KING1) {
                        if (board[i - 12] == FREE) {
                            return true;
                        }
                    }
                    if (board[i - 5] == MAN1 || board[i - 5] == KING1) {
                        if (board[i - 10] == FREE) {
                            return true;
                        }
                    }
                    if (board[i + 5] == MAN1 || board[i + 5] == KING1) {
                        if (board[i + 10] == FREE) {
                            return true;
                        }
                    }
                    if (board[i + 6] == MAN1 || board[i + 6] == KING1) {
                        if (board[i + 12] == FREE) {
                            return true;
                        }
                    }
            }
        }
        return false;
    }

    boolean checkCapture1(int i) {
        switch (board[i]) {
            case MAN1:
                // forward-left
                if (board[i - 6] == MAN2 || board[i - 6] == KING2) {
                    if (board[i - 12] == FREE) {
                        return true;
                    }
                }
                // forward-right
                if (board[i - 5] == MAN2 || board[i - 5] == KING2) {
                    if (board[i - 10] == FREE) {
                        return true;
                    }
                }
                break;

            case KING1:
                // forward-left
                if (board[i - 6] == MAN2 || board[i - 6] == KING2) {
                    if (board[i - 12] == FREE) {
                        return true;
                    }
                }
                // forward-right
                if (board[i - 5] == MAN2 || board[i - 5] == KING2) {
                    if (board[i - 10] == FREE) {
                        return true;
                    }
                }
                // backward-left
                if (board[i + 5] == MAN2 || board[i + 5] == KING2) {
                    if (board[i + 10] == FREE) {
                        return true;
                    }
                }
                // backward-right
                if (board[i + 6] == MAN2 || board[i + 6] == KING2) {
                    if (board[i + 12] == FREE) {
                        return true;
                    }
                }
        }

        return false;
    }

    void kingMove2(int from, IntGrave resMax) {
        board[from] = FREE;
        int i = from - 6;
        if (board[i] == FREE) {
            board[i] = KING2;
            turn(resMax);
            board[i] = FREE;
        }
        i = from - 5;
        if (board[i] == FREE) {
            board[i] = KING2;
            turn(resMax);
            board[i] = FREE;
        }
        i = from + 5;
        if (board[i] == FREE) {
            board[i] = KING2;
            turn(resMax);
            board[i] = FREE;
        }
        i = from + 6;
        if (board[i] == FREE) {
            board[i] = KING2;
            turn(resMax);
            board[i] = FREE;
        }
        board[from] = KING2;
    }

    boolean manCapture1(int from, int direction, BoolGrave capture) {
        int i = from + direction;
        if (board[i] == MAN2 || board[i] == KING2) {
            int k = i + direction;
            if (board[k] == FREE) {
                BoolGrave next = new BoolGrave(false);
                int save = board[i];
                board[from] = FREE;
                board[i] = NONE;
                // become a king!
                if (k < 10) {
                    board[k] = KING1;
                    /*aw?1
                    if(kingCapture1(k, direction+11, next)) {
                    board[i]=FREE;
                    return true;
                    }
                     */
                } else {
                    board[k] = MAN1;
                    if (manCapture1(k, UL, next)) {
                        board[i] = FREE;
                        return true;
                    }
                    if (manCapture1(k, UR, next)) {
                        board[i] = FREE;
                        return true;
                    }
                }
                //?? make move here, too???
                if ((!next.get()) && k == to) {
                    board[i] = FREE;
                    return true;
                }// move success
                // move failed, restore
                board[k] = FREE;
                board[i] = save;
                board[from] = MAN1;
                capture.set(true);
            }
        }
        return false;
    }

    boolean kingCapture1(int from, int direction, BoolGrave capture) {
        int i = from + direction;
        if (board[i] == MAN2 || board[i] == KING2) {
            int k = i + direction;
            if (board[k] == FREE) {
                BoolGrave next = new BoolGrave(false);
                int save = board[i];
                board[from] = FREE;
                board[i] = NONE;
                board[k] = KING1;
                if (direction == UL || direction == DR) {
                    if (kingCapture1(k, UR, next)) {
                        board[i] = FREE;
                        return true;
                    }
                    if (kingCapture1(k, DL, next)) {
                        board[i] = FREE;
                        return true;
                    }
                } else {
                    if (kingCapture1(k, UL, next)) {
                        board[i] = FREE;
                        return true;
                    }
                    if (kingCapture1(k, DR, next)) {
                        board[i] = FREE;
                        return true;
                    }
                }
                if (kingCapture1(k, direction, next)) {
                    board[i] = FREE;
                    return true;
                }
                if ((!next.get()) && k == to) {
                    board[i] = FREE;
                    return true;
                }// move ok
                // move failed, restore
                board[k] = FREE;
                board[i] = save;
                board[from] = KING1;
                capture.set(true);
            }
        }
        return false;
    }

    boolean manCapture2(int from, int direction, BoolGrave capture) {
        int i = from + direction;

        if (board[i] == MAN1 || board[i] == KING1) {
            int k = i + direction;
            if (board[k] == FREE) {
                BoolGrave next = new BoolGrave(false);
                int save = board[i];
                board[from] = FREE;
                board[i] = NONE;

                // become a king!
                if (k > 42) {//check this
                    board[k] = KING2;
                    /*aw?1            // hm see rules?
                    if(kingCapture1(k, direction+11, next)) {
                    board[i]=FREE;
                    return true;
                    }
                     */
                } else {
                    board[k] = MAN2;
                    if (manCapture2(k, DL, next)) {
                        board[i] = FREE;
                        return true;
                    }
                    if (manCapture2(k, DR, next)) {
                        board[i] = FREE;
                        return true;
                    }
                }

                //?? make move here, too???
                if ((!next.get()) && k == to) {
                    board[i] = FREE;
                    return true;
                }// move success

                // move failed, restore
                board[k] = FREE;
                board[i] = save;
                board[from] = MAN2;
                capture.set(true);
            }
        }

        return false;
    }

    boolean kingCapture2(int from, int direction, BoolGrave capture) {
        int i = from + direction;
        if (board[i] == MAN1 || board[i] == KING1) {
            int k = i + direction;
            if (board[k] == FREE) {
                BoolGrave next = new BoolGrave(false);
                int save = board[i];
                board[from] = FREE;
                board[i] = NONE;
                board[k] = KING2;

                if (direction == UL || direction == DR) {
                    if (kingCapture2(k, UR, next)) {
                        board[i] = FREE;
                        return true;
                    }
                    if (kingCapture2(k, DL, next)) {
                        board[i] = FREE;
                        return true;
                    }
                } else {
                    if (kingCapture2(k, UL, next)) {
                        board[i] = FREE;
                        return true;
                    }
                    if (kingCapture2(k, DR, next)) {
                        board[i] = FREE;
                        return true;
                    }
                }
                if (kingCapture2(k, direction, next)) {
                    board[i] = FREE;
                    return true;
                }

                if ((!next.get()) && k == to) {
                    board[i] = FREE;
                    return true;
                }// move ok

                // move failed, restore
                board[k] = FREE;
                board[i] = save;
                board[from] = KING2;
                capture.set(true);
            }
        }
        return false;
    }
    // for 2 player game

    boolean manCapture2(int from, IntGrave resMax) {
        boolean capture = false;
        // try left-down
        int i = from + 5;
        if (board[i] == MAN1 || board[i] == KING1) {
            int k = from + 10;
            if (board[k] == FREE) {
                int save = board[i];
                board[from] = FREE;
                board[i] = NONE;
                resMax.set(resMax.get() - 1);
                // become a king!
                if (from > 32) {
                    board[k] = KING2;
                    // aw?1
                    turn(resMax, true);	//aw???
                    //aw??if(!kingCapture2(k, UL, resMax)) turn(resMax, true);
                } else {
                    board[k] = MAN2;
                    if (!manCapture2(k, resMax)) {
                        turn(resMax, true);
                    }
                }
                // restore
                resMax.set(resMax.get() + 1);
                board[k] = FREE;
                board[i] = save;
                board[from] = MAN2;
                capture = true;
            }
        }
        // now right-down
        i = from + 6;
        if (board[i] == MAN1 || board[i] == KING1) {
            int k = from + 12;
            if (board[k] == FREE) {
                int save = board[i];
                board[from] = FREE;
                board[i] = NONE;
                resMax.set(resMax.get() - 1);
                // become a king!
                if (from > 32) {
                    board[k] = KING2;
                    // aw?1
                    turn(resMax, true);	// aw???
                    //aw???if(!kingCapture2(k,UR,resMax)) turn(resMax,true);
                } else {
                    board[k] = MAN2;
                    if (!manCapture2(k, resMax)) {
                        turn(resMax, true);
                    }
                }
                // restore
                resMax.set(resMax.get() + 1);
                board[k] = FREE;
                board[i] = save;
                board[from] = MAN2;
                capture = true;
            }
        }

        if (capture) {
            return true;
        }
        return false;
    }

    boolean kingCapture2(int from, int direction, IntGrave resMax) {
        int i = from + direction;
        if (board[i] == MAN1 || board[i] == KING1) {
            int k = i + direction;
            if (board[k] == FREE) {
                BoolGrave capture = new BoolGrave(false);
                int save = board[i];
                board[from] = FREE;
                board[i] = NONE;
                resMax.set(resMax.get() - 1);

                board[k] = KING2;
                if (direction == UL || direction == DR) {
                    if (kingCapture2(k, UR, resMax)) {
                        capture.set(true);
                    }
                    if (kingCapture2(k, DL, resMax)) {
                        capture.set(true);
                    }
                } else {
                    if (kingCapture2(k, UL, resMax)) {
                        capture.set(true);
                    }
                    if (kingCapture2(k, DR, resMax)) {
                        capture.set(true);
                    }
                }
                if (kingCapture2(k, direction, resMax)) {
                    capture.set(true);
                }
                if (!capture.get()) {
                    turn(resMax, true);
                }
                board[k] = FREE;
                //restore
                resMax.set(resMax.get() + 1);
                board[i] = save;
                board[from] = KING2;
                return true;
            }
        }
        return false;
    }
    //internals

    int type() {
        return 0;
    }

    ECheckers(boolean white, int lvl) {
        super(white, lvl);
    }
};

